/////////////////////////////////////////////////////////////////////////////
// ESERCIZIO 1
// Da svolgere in modo incrementale, verificando che dopo ogni fase il programma
// continui a funzionare correttamente!
// 1) Completare i pezzi mancanti facendo in modo che il programma compili
//    e giri correttamente (tag: #FASE1)
// 2) Eliminare il codice ridondante raccogliendolo a fattor comune in funzioni
//    appropriate (tag: #FASE2)
// 3) Split sorgente (necessita spiegazione :)
/////////////////////////////////////////////////////////////////////////////

// #FASE1: inserire le inclusioni mancanti
// Hint: attenzione ai messaggi d'errore del compilatore (implicit declaration...)
// Hint: per le funzioni di libreria standard vedere il man di Linux (oppure,
//       Google is your friend...)


void echo(const float* data, int length) {
  printf("BEGIN ARRAY (length=%d)\n", length);
  for(/* #FASE1: completare correttamente il loop */) {
    printf("[%3d] = %10.7e\n", i, data[i]);
  }
  printf("END ARRAY\n");
}


/*
float avg() { // #FASE2: completare la lista dei parametri (Hint: vedi sopra...)
  // #FASE2: Completare la funzione
  // Calcolo della media:
  // Inizializzazione variabile di accumulazione...
  // Loop su tutti gli elementi...
  // Accumulazione valori...
  // Calcolo media...
  return sum; // ...e ritorno il risultato.
}
*/


int main(int argc, char** argv) {
  /////////////////////////////////////////////////////////////////////////////
  // Dimensionamento statico array automatici.
  // #FASE1:  sostituire le costanti intere con una macro che venga sostituita
  //          dal preprocessore in fase di compilazione.
  /////////////////////////////////////////////////////////////////////////////
  float array_a[10];
  float array_b[10];
  int length = 10;


  /////////////////////////////////////////////////////////////////////////////
  // Stampa array non inizializzati: non molto utile ma divertente.
  // #FASE2: Sostituire entrambe le stampe con una chiamata alla funzione
  //          appropriata.
  // Hint: vedere più in basso...
  /////////////////////////////////////////////////////////////////////////////
  printf("BEGIN ARRAY (length=%d)\n", length);
  for(/* #FASE1: completare correttamente il loop */) {
    printf("[%3d] = %10.7e\n", i, array_a[i]);
  }
  printf("END ARRAY\n");
  printf("BEGIN ARRAY (length=%d)\n", length);
  for(/* #FASE1: completare correttamente il loop */) {
    printf("[%3d] = %10.7e\n", i, array_b[i]);
  }
  printf("END ARRAY\n");


  /////////////////////////////////////////////////////////////////////////////
  // Inizializzazione seme per generazione numeri (non proprio) casuali.
  // #FASE1:  aggiungere la possibilità di decidere in compilazione (via
  //          preprocessore) se usare un seme costante o variabile.
  // Hint: vedere compilazione condizionale...
  /////////////////////////////////////////////////////////////////////////////
  srand(time(NULL));


  /////////////////////////////////////////////////////////////////////////////
  // Inizializzazione degli array.
  // #FASE2:  scrivere una funzione che esegua il riempimento e sostituire i
  //          due loop sottostanti con una chiamata appropriata.
  // Hint: vedere come è stato fatto per la funzione echo() che trovate sopra...
  /////////////////////////////////////////////////////////////////////////////
  for(/* #FASE1: completare correttamente il loop */) {
    array_a[i] = (float) (rand()%100);
  }
  for(/* #FASE1: completare correttamente il loop */) {
    array_b[i] = (float) (rand()%100);
  }

  /////////////////////////////////////////////////////////////////////////////
  // Stampa array inizializzati.
  /////////////////////////////////////////////////////////////////////////////
  echo(array_a, length);
  echo(array_b, length);

  /////////////////////////////////////////////////////////////////////////////
  // Calcolo della media valori.
  // #FASE2:  scrivere una funzione che esegua il calcolo della media e ritorni
  //          il risultato; sostituire i due loop sottostanti con la chiamata
  //          appropriata.
  // Hint: vedere come è stato fatto per la funzione echo() che trovate sopra...
  /////////////////////////////////////////////////////////////////////////////
  float avg_a = 0.0f;
  float avg_b = 0.0f;
  
  for(/* #FASE1: completare correttamente il loop */) {
    avg_a += array_a[i];
  }
  avg_a /= length;

  for(/* #FASE1: completare correttamente il loop */) {
    avg_b += array_b[i];
  }
  avg_b /= length;


  /////////////////////////////////////////////////////////////////////////////
  // Stampa medie.
  /////////////////////////////////////////////////////////////////////////////
  printf("Media array a = %e\n", avg_a);
  printf("Media array b = %e\n", avg_b);

  return 0;
}
