#ifndef _PARSECMD_H_
#define _PARSEMCD_H_

// Parses the command line and retrieves matrices dimensions.
// Arguments:
//  argc	input, main-provided argument count
//  argv	input, main-provided argument vector
//  dim_a_i	output, first matrix I-dimension's size 
//  dim_a_j	output, first matrix J-dimension's size
//  dim_b_i	output, second matrix I-dimension's size
//  dim_b_j	output, second matrix J-dimension's size
void parse_cmd(int argc, char** argv, int* dim_a_i, int* dim_a_j, int* dim_b_i, int* dim_b_j);

#endif
