#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "fill.h"
#include "avg.h"
#include "echo.h"

#define ARRAY_LENGTH 10

int main(int argc, char** argv) {
  float* array_a;
  float* array_b;
  int length = ARRAY_LENGTH;

  /////////////////////////////////////////////////////////
  // Allocazione dello spazio necessario:
  // scrivere una funzione che allochi il singolo vettore.

  /////////////////////////////////////////////////////////    
  /////////////////////////////////////////////////////////
  // Da questo punto in poi, il codice è scritto per lavorare
  // con array monodimensionali. E' necessario modificarlo
  // (comprese le funzioni esterne) per l'utilizzo di matrici 2D.
  /////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////

  // Stampa array non inizializzati:
  // non molto utile ma divertente
  echo(array_a, length);
  echo(array_b, length);

  // Inizializzazione seme per generazione
  // numeri (non proprio) casuali.
  #ifdef DISABLE_RANDOM
  srand(1);
  #else
  srand(time(NULL));
  #endif

  // Riempimento array
  fill(array_a, length);
  fill(array_b, length);

  // Stampa array inizializzati
  echo(array_a, length);
  echo(array_b, length);

  // Calcolo media
  float avg_a = avg(array_a, length);
  float avg_b = avg(array_b, length);

  // Stampa medie
  printf("Media array a = %e\n", avg_a);
  printf("Media array b = %e\n", avg_b);

  // Deallocazione dello spazio necessario.

  return 0;
}
